/* 
 * arch/arm/mach-uniphier/include/mach/nand_partition.h
 *
 * Copyright (C) 2011 Panasonic Corporation
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * Generated by   NANDP_GenerationTool.xls
 */

#ifndef	__ASM_ARCH_NAND_PARTITION_H
#define	__ASM_ARCH_NAND_PARTITION_H
#include <linux/config.h>

#if defined(CONFIG_MTD_NAND_MAP_V2)
#if (CONFIG_MTD_NAND_MN2WS_CHIP_SIZE_GBIT==2)
static struct mtd_partition nand_gpbc_partition_info[] = {
  { .offset = 0x00000000, .size = 0x00100000, .name = "nand_2ndboot", },
  { .offset = 0x00100000, .size = 0x00040000, .name = "v3rdboot", },
  { .offset = 0x00140000, .size = 0x00040000, .name = "vuboot", },
  { .offset = 0x00180000, .size = 0x00400000, .name = "vucode", },
  { .offset = 0x00580000, .size = 0x00a00000, .name = "vkernel", },
  { .offset = 0x00f80000, .size = 0x00020000, .name = "model_info", },
  { .offset = 0x00fa0000, .size = 0x00020000, .name = "swupdate_flag", },
  { .offset = 0x00fc0000, .size = 0x00040000, .name = "uboot_env", },
  { .offset = 0x01000000, .size = 0x000a0000, .name = "param", },

  { .offset = 0x010a0000, .size = 0x00040000, .name = "3rdboot_a", },
  { .offset = 0x010e0000, .size = 0x00040000, .name = "uboot_a", },
  { .offset = 0x01120000, .size = 0x00400000, .name = "ucode_a", },
  { .offset = 0x01520000, .size = 0x00400000, .name = "kernel_a", },
  { .offset = 0x01920000, .size = 0x00880000, .name = "rfs_a", },
  { .offset = 0x021a0000, .size = 0x03e80000, .name = "usr_a", },

  { .offset = 0x06020000, .size = 0x00040000, .name = "3rdboot_b", },
  { .offset = 0x06060000, .size = 0x00040000, .name = "uboot_b", },
  { .offset = 0x060a0000, .size = 0x00400000, .name = "ucode_b", },
  { .offset = 0x064a0000, .size = 0x00400000, .name = "kernel_b", },
  { .offset = 0x068a0000, .size = 0x00880000, .name = "rfs_b", },
  { .offset = 0x07120000, .size = 0x03e80000, .name = "usr_b", },

  { .offset = 0x0afa0000, .size = 0x00040000, .name = "3rd", },
  { .offset = 0x0afe0000, .size = 0x01e00000, .name = "sys_data", },
  { .offset = 0x0cde0000, .size = 0x00500000, .name = "usr_data", },
  { .offset = 0x0d2e0000, .size = 0x01e00000, .name = "ro_data", },
  { .offset = 0x0f0e0000, .size = 0x00700000, .name = "tmp", },
  { .offset = 0x0f7e0000, .size = 0x00020000, .name = "manual", },
  { .offset = 0x0f800000, .size = 0x00800000, .name = "sys_bbm", }
  };

#if defined(CONFIG_NANDBOOT_BANKCHOICE)
static struct mtd_partition nand_gpbc_partition_info1[] = {
  { .offset = 0x00000000, .size = 0x00100000, .name = "nand_2ndboot", },
  { .offset = 0x00100000, .size = 0x00040000, .name = "v3rdboot", },
  { .offset = 0x00140000, .size = 0x00040000, .name = "vuboot", },
  { .offset = 0x00180000, .size = 0x00400000, .name = "vucode", },
  { .offset = 0x00580000, .size = 0x00a00000, .name = "vkernel", },
  { .offset = 0x00f80000, .size = 0x00020000, .name = "model_info", },
  { .offset = 0x00fa0000, .size = 0x00020000, .name = "swupdate_flag", },
  { .offset = 0x00fc0000, .size = 0x00040000, .name = "uboot_env", },
  { .offset = 0x01000000, .size = 0x000a0000, .name = "param", },

  { .offset = 0x010a0000, .size = 0x00040000, .name = "3rdboot_a", },
  { .offset = 0x010e0000, .size = 0x00040000, .name = "uboot_a", },
  { .offset = 0x01120000, .size = 0x00400000, .name = "ucode_a", },
  { .offset = 0x01520000, .size = 0x00400000, .name = "kernel_a", },
  { .offset = 0x01920000, .size = 0x00880000, .name = "rfs_a", },
  { .offset = 0x021a0000, .size = 0x03e80000, .name = "usr_a", },

  { .offset = 0x06020000, .size = 0x00040000, .name = "3rdboot_b", },
  { .offset = 0x06060000, .size = 0x00040000, .name = "uboot_b", },
  { .offset = 0x060a0000, .size = 0x00400000, .name = "ucode_b", },
  { .offset = 0x064a0000, .size = 0x00400000, .name = "kernel_b", },
  { .offset = 0x068a0000, .size = 0x00880000, .name = "rfs_b", },
  { .offset = 0x07120000, .size = 0x03e80000, .name = "usr_b", },

  { .offset = 0x0afa0000, .size = 0x00040000, .name = "3rd", },
  { .offset = 0x0afe0000, .size = 0x01e00000, .name = "sys_data", },
  { .offset = 0x0cde0000, .size = 0x00500000, .name = "usr_data", },
  { .offset = 0x0d2e0000, .size = 0x01e00000, .name = "ro_data", },
  { .offset = 0x0f0e0000, .size = 0x00700000, .name = "tmp", },
  { .offset = 0x0f7e0000, .size = 0x00020000, .name = "manual", },
  { .offset = 0x0f800000, .size = 0x00800000, .name = "sys_bbm", }
  };
#endif

#elif (CONFIG_MTD_NAND_MN2WS_CHIP_SIZE_GBIT==4)
/* add conditional coding in accordance with BUILDCONFIG_MODEL(K20/J20) (sharp 2014/01/15) */
#  if defined(SH_CONFIG_BUILD_MODEL_K20) /* SDK V0011 or later (K20 Build with using spansion NAND) */
static struct mtd_partition nand_gpbc_partition_info[] = {
  { .offset = 0x00000000, .size = 0x00100000, .name = "nand_2ndboot", },
  { .offset = 0x00100000, .size = 0x00040000, .name = "v3rdboot", },
  { .offset = 0x00140000, .size = 0x00040000, .name = "vuboot", },
  { .offset = 0x00180000, .size = 0x00400000, .name = "vucode", },
  { .offset = 0x00580000, .size = 0x00a00000, .name = "vkernel", },
  { .offset = 0x00f80000, .size = 0x00020000, .name = "model_info", },
  { .offset = 0x00fa0000, .size = 0x00020000, .name = "swupdate_flag", },
  { .offset = 0x00fc0000, .size = 0x00040000, .name = "uboot_env", },
  { .offset = 0x01000000, .size = 0x000a0000, .name = "param", },

  { .offset = 0x010a0000, .size = 0x00040000, .name = "3rdboot_a", },
  { .offset = 0x010e0000, .size = 0x00040000, .name = "uboot_a", },
  { .offset = 0x01120000, .size = 0x00400000, .name = "ucode_a", },
  { .offset = 0x01520000, .size = 0x00400000, .name = "kernel_a", },
  { .offset = 0x01920000, .size = 0x00880000, .name = "rfs_a", },
  { .offset = 0x021a0000, .size = 0x03e80000, .name = "usr_a", },

  { .offset = 0x06020000, .size = 0x00040000, .name = "3rdboot_b", },
  { .offset = 0x06060000, .size = 0x00040000, .name = "uboot_b", },
  { .offset = 0x060a0000, .size = 0x00400000, .name = "ucode_b", },
  { .offset = 0x064a0000, .size = 0x00400000, .name = "kernel_b", },
  { .offset = 0x068a0000, .size = 0x00880000, .name = "rfs_b", },
  { .offset = 0x07120000, .size = 0x03e80000, .name = "usr_b", },

  { .offset = 0x0afa0000, .size = 0x00040000, .name = "3rd", },
  { .offset = 0x0afe0000, .size = 0x01e00000, .name = "sys_data", },
  { .offset = 0x0cde0000, .size = 0x00500000, .name = "usr_data", },
  { .offset = 0x0d2e0000, .size = 0x01e00000, .name = "ro_data", },
  { .offset = 0x0f0e0000, .size = 0x00700000, .name = "tmp", },
  { .offset = 0x0f7e0000, .size = 0x00020000, .name = "manual", },
  { .offset = 0x0f800000, .size = 0x10800000, .name = "sys_bbm", }
  };
#    if defined(CONFIG_NANDBOOT_BANKCHOICE)
static struct mtd_partition nand_gpbc_partition_info1[] = {
  { .offset = 0x00000000, .size = 0x00100000, .name = "nand_2ndboot", },
  { .offset = 0x00100000, .size = 0x00040000, .name = "v3rdboot", },
  { .offset = 0x00140000, .size = 0x00040000, .name = "vuboot", },
  { .offset = 0x00180000, .size = 0x00400000, .name = "vucode", },
  { .offset = 0x00580000, .size = 0x00a00000, .name = "vkernel", },
  { .offset = 0x00f80000, .size = 0x00020000, .name = "model_info", },
  { .offset = 0x00fa0000, .size = 0x00020000, .name = "swupdate_flag", },
  { .offset = 0x00fc0000, .size = 0x00040000, .name = "uboot_env", },
  { .offset = 0x01000000, .size = 0x000a0000, .name = "param", },

  { .offset = 0x010a0000, .size = 0x00040000, .name = "3rdboot_a", },
  { .offset = 0x010e0000, .size = 0x00040000, .name = "uboot_a", },
  { .offset = 0x01120000, .size = 0x00400000, .name = "ucode_a", },
  { .offset = 0x01520000, .size = 0x00400000, .name = "kernel_a", },
  { .offset = 0x01920000, .size = 0x00880000, .name = "rfs_a", },
  { .offset = 0x021a0000, .size = 0x03e80000, .name = "usr_a", },

  { .offset = 0x06020000, .size = 0x00040000, .name = "3rdboot_b", },
  { .offset = 0x06060000, .size = 0x00040000, .name = "uboot_b", },
  { .offset = 0x060a0000, .size = 0x00400000, .name = "ucode_b", },
  { .offset = 0x064a0000, .size = 0x00400000, .name = "kernel_b", },
  { .offset = 0x068a0000, .size = 0x00880000, .name = "rfs_b", },
  { .offset = 0x07120000, .size = 0x03e80000, .name = "usr_b", },

  { .offset = 0x0afa0000, .size = 0x00040000, .name = "3rd", },
  { .offset = 0x0afe0000, .size = 0x01e00000, .name = "sys_data", },
  { .offset = 0x0cde0000, .size = 0x00500000, .name = "usr_data", },
  { .offset = 0x0d2e0000, .size = 0x01e00000, .name = "ro_data", },
  { .offset = 0x0f0e0000, .size = 0x00700000, .name = "tmp", },
  { .offset = 0x0f7e0000, .size = 0x00020000, .name = "manual", },
  { .offset = 0x0f800000, .size = 0x10800000, .name = "sys_bbm", }
  };
#    endif /* if defined(CONFIG_NANDBOOT_BANKCHOICE) */
/* add conditional coding in accordance with BUILDCONFIG_MODEL(K20/J20) (sharp 2014/01/15) */
#  elif defined(SH_CONFIG_BUILD_MODEL_J20)	/* based on SDK V0010 (J20 Build with using spansion NAND) */
#    if (CONFIG_MTD_NAND_MN2WS_CHIP_BLOCKSIZE==0x20000)
static struct mtd_partition nand_gpbc_partition_info[] = {
  { .offset = 0x00000000, .size = 0x00020000, .name = "nand_2ndboot", },
  { .offset = 0x00020000, .size = 0x00040000, .name = "v3rdboot", },
  { .offset = 0x00060000, .size = 0x00040000, .name = "vuboot", },
  { .offset = 0x000a0000, .size = 0x00800000, .name = "vucode", },
  { .offset = 0x008a0000, .size = 0x00a00000, .name = "vkernel", },
  { .offset = 0x012a0000, .size = 0x00100000, .name = "model_info", },
  { .offset = 0x013a0000, .size = 0x00080000, .name = "swupdate_flag", },
  { .offset = 0x01420000, .size = 0x00040000, .name = "uboot_env", },
  { .offset = 0x01460000, .size = 0x000a0000, .name = "param", },
  
  { .offset = 0x01500000, .size = 0x00040000, .name = "3rdboot_a", },
  { .offset = 0x01540000, .size = 0x00040000, .name = "uboot_a", },
  { .offset = 0x01580000, .size = 0x00800000, .name = "ucode_a", },
  { .offset = 0x01d80000, .size = 0x00a00000, .name = "kernel_a", },
  { .offset = 0x02780000, .size = 0x00a00000, .name = "rfs_a", },
  { .offset = 0x03180000, .size = 0x05000000, .name = "usr_a", },
  
  { .offset = 0x08180000, .size = 0x00040000, .name = "3rdboot_b", },
  { .offset = 0x081c0000, .size = 0x00040000, .name = "uboot_b", },
  { .offset = 0x08200000, .size = 0x00800000, .name = "ucode_b", },
  { .offset = 0x08a00000, .size = 0x00a00000, .name = "kernel_b", },
  { .offset = 0x09400000, .size = 0x00a00000, .name = "rfs_b", },
  { .offset = 0x09e00000, .size = 0x05000000, .name = "usr_b", },
  
  { .offset = 0x0ee00000, .size = 0x06400000, .name = "3rd", },
  { .offset = 0x15200000, .size = 0x01e00000, .name = "sys_data", },
  { .offset = 0x17000000, .size = 0x02800000, .name = "usr_data", },
  { .offset = 0x19800000, .size = 0x01e00000, .name = "ro_data", },
  { .offset = 0x1b600000, .size = 0x00700000, .name = "tmp", },
  { .offset = 0x1bd00000, .size = 0x03300000, .name = "manual", },
  { .offset = 0x1f000000, .size = 0x01000000, .name = "sys_bbm", }
  };
#      if defined(CONFIG_NANDBOOT_BANKCHOICE)
static struct mtd_partition nand_gpbc_partition_info1[] = {
  { .offset = 0x00000000, .size = 0x00020000, .name = "nand_2ndboot", },
  { .offset = 0x00020000, .size = 0x00040000, .name = "v3rdboot", },
  { .offset = 0x00060000, .size = 0x00040000, .name = "vuboot", },
  { .offset = 0x000a0000, .size = 0x00800000, .name = "vucode", },
  { .offset = 0x008a0000, .size = 0x00a00000, .name = "vkernel", },
  { .offset = 0x012a0000, .size = 0x00100000, .name = "model_info", },
  { .offset = 0x013a0000, .size = 0x00080000, .name = "swupdate_flag", },
  { .offset = 0x01420000, .size = 0x00040000, .name = "uboot_env", },
  { .offset = 0x01460000, .size = 0x000a0000, .name = "param", },
  
  { .offset = 0x01500000, .size = 0x00040000, .name = "3rdboot_a", },
  { .offset = 0x01540000, .size = 0x00040000, .name = "uboot_a", },
  { .offset = 0x01580000, .size = 0x00800000, .name = "ucode_a", },
  { .offset = 0x01d80000, .size = 0x00a00000, .name = "kernel_a", },
  { .offset = 0x02780000, .size = 0x00a00000, .name = "rfs_a", },
  { .offset = 0x03180000, .size = 0x05000000, .name = "usr_a", },
  
  { .offset = 0x08180000, .size = 0x00040000, .name = "3rdboot_b", },
  { .offset = 0x081c0000, .size = 0x00040000, .name = "uboot_b", },
  { .offset = 0x08200000, .size = 0x00800000, .name = "ucode_b", },
  { .offset = 0x08a00000, .size = 0x00a00000, .name = "kernel_b", },
  { .offset = 0x09400000, .size = 0x00a00000, .name = "rfs_b", },
  { .offset = 0x09e00000, .size = 0x05000000, .name = "usr_b", },
  
  { .offset = 0x0ee00000, .size = 0x06400000, .name = "3rd", },
  { .offset = 0x15200000, .size = 0x01e00000, .name = "sys_data", },
  { .offset = 0x17000000, .size = 0x02800000, .name = "usr_data", },
  { .offset = 0x19800000, .size = 0x01e00000, .name = "ro_data", },
  { .offset = 0x1b600000, .size = 0x00700000, .name = "tmp", },
  { .offset = 0x1bd00000, .size = 0x03300000, .name = "manual", },
  { .offset = 0x1f000000, .size = 0x01000000, .name = "sys_bbm", }
  };
#      endif /* if defined(CONFIG_NANDBOOT_BANKCHOICE) */
#    elif (CONFIG_MTD_NAND_MN2WS_CHIP_BLOCKSIZE==0x40000)
static struct mtd_partition nand_gpbc_partition_info[] = {
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00000000, .size = 0x00100000, .name = "nand_2ndboot", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00100000, .size = 0x00040000, .name = "v3rdboot", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00140000, .size = 0x00040000, .name = "vuboot", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00180000, .size = 0x00400000, .name = "vucode", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00580000, .size = 0x00a00000, .name = "vkernel", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00f80000, .size = 0x00020000, .name = "model_info", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00fa0000, .size = 0x00020000, .name = "swupdate_flag", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00fc0000, .size = 0x00040000, .name = "uboot_env", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x01000000, .size = 0x000a0000, .name = "param", },
/*[TODO] refine nand map for the actual Net-model product */
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x010a0000, .size = 0x00040000, .name = "3rdboot_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x010e0000, .size = 0x00040000, .name = "uboot_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x01120000, .size = 0x00400000, .name = "ucode_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x01520000, .size = 0x00400000, .name = "kernel_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x01920000, .size = 0x00880000, .name = "rfs_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x021a0000, .size = 0x03e80000, .name = "usr_a", },
/*[TODO] refine nand map for the actual Net-model product */
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x06020000, .size = 0x00040000, .name = "3rdboot_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x06060000, .size = 0x00040000, .name = "uboot_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x060a0000, .size = 0x00400000, .name = "ucode_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x064a0000, .size = 0x00400000, .name = "kernel_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x068a0000, .size = 0x00880000, .name = "rfs_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x07120000, .size = 0x03e80000, .name = "usr_b", },
/*[TODO] refine nand map for the actual Net-model product */
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0afa0000, .size = 0x00040000, .name = "3rd", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0afe0000, .size = 0x01e00000, .name = "sys_data", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0cde0000, .size = 0x00500000, .name = "usr_data", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0d2e0000, .size = 0x01e00000, .name = "ro_data", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0f0e0000, .size = 0x00700000, .name = "tmp", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0f7e0000, .size = 0x00020000, .name = "manual", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0f800000, .size = 0x10800000, .name = "sys_bbm", }
  };

#      if defined(CONFIG_NANDBOOT_BANKCHOICE)
static struct mtd_partition nand_gpbc_partition_info1[] = {
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00000000, .size = 0x00100000, .name = "nand_2ndboot", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00100000, .size = 0x00040000, .name = "v3rdboot", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00140000, .size = 0x00040000, .name = "vuboot", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00180000, .size = 0x00400000, .name = "vucode", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00580000, .size = 0x00a00000, .name = "vkernel", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00f80000, .size = 0x00020000, .name = "model_info", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00fa0000, .size = 0x00020000, .name = "swupdate_flag", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x00fc0000, .size = 0x00040000, .name = "uboot_env", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x01000000, .size = 0x000a0000, .name = "param", },
/*[TODO] refine nand map for the actual Net-model product */
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x010a0000, .size = 0x00040000, .name = "3rdboot_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x010e0000, .size = 0x00040000, .name = "uboot_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x01120000, .size = 0x00400000, .name = "ucode_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x01520000, .size = 0x00400000, .name = "kernel_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x01920000, .size = 0x00880000, .name = "rfs_a", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x021a0000, .size = 0x03e80000, .name = "usr_a", },
/*[TODO] refine nand map for the actual Net-model product */
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x06020000, .size = 0x00040000, .name = "3rdboot_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x06060000, .size = 0x00040000, .name = "uboot_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x060a0000, .size = 0x00400000, .name = "ucode_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x064a0000, .size = 0x00400000, .name = "kernel_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x068a0000, .size = 0x00880000, .name = "rfs_b", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x07120000, .size = 0x03e80000, .name = "usr_b", },
/*[TODO] refine nand map for the actual Net-model product */
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0afa0000, .size = 0x00040000, .name = "3rd", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0afe0000, .size = 0x01e00000, .name = "sys_data", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0cde0000, .size = 0x00500000, .name = "usr_data", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0d2e0000, .size = 0x01e00000, .name = "ro_data", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0f0e0000, .size = 0x00700000, .name = "tmp", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0f7e0000, .size = 0x00020000, .name = "manual", },
/*[TODO] refine nand map for the actual Net-model product */  { .offset = 0x0f800000, .size = 0x10800000, .name = "sys_bbm", }
  };
#      endif /* if defined(CONFIG_NANDBOOT_BANKCHOICE) */
#    endif /* (CONFIG_MTD_NAND_MN2WS_CHIP_BLOCKSIZE==0xXXXXX */
/* add conditional coding in accordance with BUILDCONFIG_MODEL(K20/J20) (sharp 2014/01/15) */
#  else
     #error Build Model Unknown !!
#  endif
#elif (CONFIG_MTD_NAND_MN2WS_CHIP_SIZE_GBIT==16)
static struct mtd_partition nand_gpbc_partition_info[] = {
  { .offset = 0x00000000, .size = 0x00020000, .name = "nand_2ndboot", },
  { .offset = 0x00020000, .size = 0x00040000, .name = "v3rdboot", },
  { .offset = 0x00060000, .size = 0x00040000, .name = "vuboot", },
  { .offset = 0x000a0000, .size = 0x00800000, .name = "vucode", },
  { .offset = 0x008a0000, .size = 0x00a00000, .name = "vkernel", },
  { .offset = 0x012a0000, .size = 0x00100000, .name = "model_info", },
  { .offset = 0x013a0000, .size = 0x00080000, .name = "swupdate_flag", },
  { .offset = 0x01420000, .size = 0x00040000, .name = "uboot_env", },
  { .offset = 0x01460000, .size = 0x000a0000, .name = "param", },

  { .offset = 0x01500000, .size = 0x00040000, .name = "3rdboot_a", },
  { .offset = 0x01540000, .size = 0x00040000, .name = "uboot_a", },
  { .offset = 0x01580000, .size = 0x00800000, .name = "ucode_a", },
  { .offset = 0x01d80000, .size = 0x00a00000, .name = "kernel_a", },
  { .offset = 0x02780000, .size = 0x00a00000, .name = "rfs_a", },
  { .offset = 0x03180000, .size = 0x05000000, .name = "usr_a", },

  { .offset = 0x08180000, .size = 0x00040000, .name = "3rdboot_b", },
  { .offset = 0x081c0000, .size = 0x00040000, .name = "uboot_b", },
  { .offset = 0x08200000, .size = 0x00800000, .name = "ucode_b", },
  { .offset = 0x08a00000, .size = 0x00a00000, .name = "kernel_b", },
  { .offset = 0x09400000, .size = 0x00a00000, .name = "rfs_b", },
  { .offset = 0x09e00000, .size = 0x05000000, .name = "usr_b", },

  { .offset = 0x0ee00000, .size = 0x06400000, .name = "3rd", },
  { .offset = 0x15200000, .size = 0x01e00000, .name = "sys_data", },
  { .offset = 0x17000000, .size = 0x02800000, .name = "usr_data", },
  { .offset = 0x19800000, .size = 0x01e00000, .name = "ro_data", },
  { .offset = 0x1b600000, .size = 0x00700000, .name = "tmp", },
  { .offset = 0x1bd00000, .size = 0x03300000, .name = "manual", },
  #if (CONFIG_MTD_NAND_MN2WS_CHIP_BANK == 1)
  { .offset = 0x1f000000, .size = 0x01000000, .name = "sys_bbm", }

  #elif (CONFIG_MTD_NAND_MN2WS_CHIP_BANK == 2) /* only 16Gbit NAND supported */
  { .offset = 0x1f000000, .size = 0x1f000000, .name = "nand_sys_reserved1", },
  { .offset = 0x3e000000, .size = 0x02000000, .name = "nand_sys_bbm1", },
  { .offset = 0x40000000, .size = 0x3e000000, .name = "nand_sys_reserved2", },
  { .offset = 0x7e000000, .size = 0x02000000, .name = "nand_sys_bbm2", },
  #endif
  };

#if defined(CONFIG_NANDBOOT_BANKCHOICE)
static struct mtd_partition nand_gpbc_partition_info1[] = {
  { .offset = 0x00000000, .size = 0x00020000, .name = "nand_2ndboot", },
  { .offset = 0x00020000, .size = 0x00040000, .name = "v3rdboot", },
  { .offset = 0x00060000, .size = 0x00040000, .name = "vuboot", },
  { .offset = 0x000a0000, .size = 0x00800000, .name = "vucode", },
  { .offset = 0x008a0000, .size = 0x00a00000, .name = "vkernel", },
  { .offset = 0x012a0000, .size = 0x00100000, .name = "model_info", },
  { .offset = 0x013a0000, .size = 0x00080000, .name = "swupdate_flag", },
  { .offset = 0x01420000, .size = 0x00040000, .name = "uboot_env", },
  { .offset = 0x01460000, .size = 0x000a0000, .name = "param", },

  { .offset = 0x01500000, .size = 0x00040000, .name = "3rdboot_a", },
  { .offset = 0x01540000, .size = 0x00040000, .name = "uboot_a", },
  { .offset = 0x01580000, .size = 0x00800000, .name = "ucode_a", },
  { .offset = 0x01d80000, .size = 0x00a00000, .name = "kernel_a", },
  { .offset = 0x02780000, .size = 0x00a00000, .name = "rfs_a", },
  { .offset = 0x03180000, .size = 0x05000000, .name = "usr_a", },

  { .offset = 0x08180000, .size = 0x00040000, .name = "3rdboot_b", },
  { .offset = 0x081c0000, .size = 0x00040000, .name = "uboot_b", },
  { .offset = 0x08200000, .size = 0x00800000, .name = "ucode_b", },
  { .offset = 0x08a00000, .size = 0x00a00000, .name = "kernel_b", },
  { .offset = 0x09400000, .size = 0x00a00000, .name = "rfs_b", },
  { .offset = 0x09e00000, .size = 0x05000000, .name = "usr_b", },

  { .offset = 0x0ee00000, .size = 0x06400000, .name = "3rd", },
  { .offset = 0x15200000, .size = 0x01e00000, .name = "sys_data", },
  { .offset = 0x17000000, .size = 0x02800000, .name = "usr_data", },
  { .offset = 0x19800000, .size = 0x01e00000, .name = "ro_data", },
  { .offset = 0x1b600000, .size = 0x00700000, .name = "tmp", },
  { .offset = 0x1bd00000, .size = 0x03300000, .name = "manual", },
  #if (CONFIG_MTD_NAND_MN2WS_CHIP_BANK == 1)
  { .offset = 0x1f000000, .size = 0x01000000, .name = "sys_bbm", }

  #elif (CONFIG_MTD_NAND_MN2WS_CHIP_BANK == 2) /* only 16Gbit NAND supported */
  { .offset = 0x1f000000, .size = 0x1f000000, .name = "nand_sys_reserved1", },
  { .offset = 0x3e000000, .size = 0x02000000, .name = "nand_sys_bbm1", },
  { .offset = 0x40000000, .size = 0x3e000000, .name = "nand_sys_reserved2", },
  { .offset = 0x7e000000, .size = 0x02000000, .name = "nand_sys_bbm2", },
  #endif
  };
#endif


#else
# error Unexpected NAND Size !!
#endif

#else
# error Unknown NAND MAP version !!
#endif
#endif
